/***
    PandoraLocal
***/
Ox.load('UI', {
    hideScreen: false,
    showScreen: true,
    theme: 'classic'
}, function() {

window.pandora = new Ox.App({
    apiURL: '/api/',
    init: 'init',
}).bindEvent('load', function(data) {
    pandora.site = {
    };
    Ox.UI.hideLoadingScreen();

    pandora.$ui = {
        body: $('body'),
        document: $(document),
        window: $(window)
            .bind({
                resize: function() {
                    //pandora.resizeWindow();
                },
                unload: function() {
                    //pandora.nloadWindow();
                }
            })
    };
    pandora.$ui.volumes = constructList();
    pandora.$ui.files = constructFiles();

    var $left = new Ox.SplitPanel({
        elements: [
            {
                element: new Ox.Element().append(new Ox.Element()
                .html('Pandoralocal').css({
                    'padding': '4px',
                })).css({
                    'background-color': '#ddd',
                    'font-weight': 'bold',
                }),
                size: 24
            },
            {
                element: pandora.$ui.volumes
            }
        ],
        orientation: 'vertical'
    });
    var $main = new Ox.SplitPanel({
        elements: [
            {
                element: $left,
                size: 160
            },
            {
                element: pandora.$ui.files,
            }
        ],
        orientation: 'horizontal'
    });

    $main.appendTo(pandora.$ui.body);
});

function constructFiles() {
    return new Ox.TextList({
        columns: [
                {
                    align: "left",
                    id: "path",
                    operator: "+",
                    title: "Name",
                    unique: true,
                    visible: true,
                    width: 860
                },
                {
                    align: "left",
                    id: "size",
                    operator: "-",
                    title: "Size",
                    visible: true,
                    width: 120
                },
                {
                    align: "left",
                    id: "oshash",
                    operator: "-",
                    title: "ID",
                    visible: true,
                    width: 120
                },
        ],
        columnsMovable: true,
        columnsRemovable: true,
        items: pandora.api.findFiles,
        scrollbarVisible: true,
        sort: [
            {
                key: "path",
                operator: "+"
            }
        ]
    }).bindEvent({
       select: function(data) {
           var info = $('<div>').addClass('OxSelectable'),
               hash = '#';
           if(data.ids.length) {
              data.ids.forEach(function(id) {
                info.append($("<h2>").html(id));
                var $doc =$('<pre>')
                           .html(pandora.actions[id].doc.replace('/\n/<br>\n/g'))
                           .appendTo(info);
                var $code = $('<code class="python">')
                             .html(pandora.actions[id].code[1].replace('/\n/<br>\n/g'))
                             .hide();
                var f = pandora.actions[id].code[0];
                $('<span>')
                  .html(' View Source ('+f+')')
                  .click(function() { $code.toggle();})
                  .appendTo(info);
                $('<pre>').append($code).appendTo(info);
                hljs.highlightBlock($code[0], '    ');

                hash += id + ',';
              });
          } else {
            info.html(pandora.site.default_info);
          }

            document.location.hash = hash.substring(0, hash.length-1);
            pandora.$ui.actionInfo.html(info);
       }
    });
}

function constructList() {
    return new Ox.TextList({
        columns: [
                {
                    align: "left",
                    id: "name",
                    operator: "+",
                    title: "Name",
                    unique: true,
                    visible: true,
                    width: 140
                },
        ],
        columnsMovable: false,
        columnsRemovable: false,
        id: 'actionList',
        items: function(data, callback) {
            function _sort(a, b) {
                if(a.name > b.name)
                    return 1;
                else if(a.name == b.name)
                    return 0;
                return -1;
            }
            pandora.api.findVolumes(function(result) {
                var items = result.data.items;
                items.sort(_sort);
                callback({'data': {
                    'items': data.keys ? items : items.length
                }});
            });
        },
        scrollbarVisible: true,
        sort: [
            {
                key: "name",
                operator: "+"
            }
        ]
    }).bindEvent({
        select: function(data) {
            if(data.ids.length) {
                var volume = data.ids[0];
                Ox.print("FIXME", volume);
            }
        }
    });
}
});

