# setup.py
# -*- coding: UTF-8 -*-
# vi:si:et:sw=4:sts=4:ts=4
from distutils.core import setup
import os

def get_version():
    from pandoralocal.version import __version__
    info = os.path.join(os.path.dirname(__file__), '.bzr/branch/last-revision')
    if os.path.exists(info):
        f = open(info)
        rev = int(f.read().split()[0])
        f.close()
        if rev:
            return '%s.%s' % (__version__, rev)
    return '%s'%__version__

def get_package_data():
    package_data = []
    for root, folders, files in os.walk('pandoralocal/static'):
        for f in files:
            package_data.append(os.path.join(root, f)[len('pandoralocal/'):])
    return package_data

setup(name="pandoralocal",
    version=get_version() ,
    scripts=[
        'bin/pandoralocal',
    ],
    packages=[
        'pandoralocal',
    ],
    package_data = {
        'pandoralocal': get_package_data(),
    },
    author="0x2620",
    author_email="0x2620@0x2620.org",
    description=u"pandoralocal allows users to use local videos on a pan.do/ra site",
    classifiers = [
        'Development Status :: 4 - Beta',
        'Operating System :: OS Independent',
        'Programming Language :: Python',
    ],
)

